{
  SEQ(ڵ) ʵ AutoGenerateValue := arAutoInc   
  Ǵ UpataOptions.AutoIncFields SEQ  ʵ ߰
}
unit DataAccessModule;

interface

uses
  System.SysUtils, System.Classes, FireDAC.Stan.Intf, FireDAC.Stan.Option,
  FireDAC.Stan.Error, FireDAC.UI.Intf, FireDAC.Phys.Intf, FireDAC.Stan.Def,
  FireDAC.Stan.Pool, FireDAC.Stan.Async, FireDAC.Phys, FireDAC.Phys.IB,
  FireDAC.Phys.IBDef, FireDAC.VCLUI.Wait, FireDAC.Stan.Param, FireDAC.DatS,
  FireDAC.DApt.Intf, FireDAC.DApt, Data.DB, FireDAC.Comp.DataSet,
  FireDAC.Comp.Client, FireDAC.Phys.IBBase, FireDAC.Comp.UI;

type
  TdmDataAccess = class(TDataModule)
    conPrjMng: TFDConnection;
    tblDept: TFDTable;
    tblMember: TFDTable;
    tblDeptDPT_SEQ: TIntegerField;
    tblDeptDPT_DEPT: TWideStringField;
    tblDeptDPT_TEAM: TWideStringField;
    FDGUIxWaitCursor1: TFDGUIxWaitCursor;
    FDPhysIBDriverLink1: TFDPhysIBDriverLink;
    tblMemberMEM_SEQ: TFDAutoIncField;
    tblMemberMEM_NAME: TWideStringField;
    tblMemberMEM_TEAM_SEQ: TIntegerField;
    tblMemberMEM_TEAM: TStringField;
    tblProject: TFDTable;
    dsProject: TDataSource;
    tblProjectPRJ_SEQ: TIntegerField;
    tblProjectPRJ_NAME: TWideStringField;
    tblProjectPRJ_MANAGER_SEQ: TIntegerField;
    tblProjectPRJ_MEMBERCOUNT: TIntegerField;
    tblProjectPRJ_STATUS_CODE: TIntegerField;
    tblProjectPRJ_MANAGER: TStringField;
    tblProjectPRJ_STATUS: TStringField;
    qryUpdatePrjMem: TFDQuery;
    qryProjectMember: TFDQuery;
    qryProjectMemberPRM_PRJ_SEQ: TIntegerField;
    qryProjectMemberMEM_NAME: TWideStringField;
    qryProjectMemberDPT_TEAM: TWideStringField;
    qryProjectMemberPRM_MEM_SEQ: TIntegerField;
    tblProjectPRJ_STARTDATE: TDateField;
    tblProjectPRJ_ENDDATE: TDateField;
    tblMemberMEM_YEAR_SALARY: TIntegerField;
    tblMemberMEM_MONTH_SALARY: TIntegerField;
    tblMemberSALARY_SUM: TAggregateField;
    FDQuery1: TFDQuery;
    procedure tblProjectCalcFields(DataSet: TDataSet);
    procedure tblProjectNewRecord(DataSet: TDataSet);
    procedure tblMemberCalcFields(DataSet: TDataSet);
    procedure DataModuleCreate(Sender: TObject);
  private
    { Private declarations }
    procedure UpdateProjectMemberCount(const APrjSeq: Integer);
  public
    { Public declarations }
    procedure AppendProjectMember(const APrjSeq, AMemSeq: Integer);
    procedure DeleteProjectMember(const APrjSeq, AMemSeq: Integer);

    procedure DeleteProject;
  end;

var
  dmDataAccess: TdmDataAccess;

implementation

{%CLASSGROUP 'Vcl.Controls.TControl'}

{$R *.dfm}

uses
  Vcl.Dialogs;

// DataSet óص ǳ SQL óϴ   
procedure TdmDataAccess.AppendProjectMember(const APrjSeq, AMemSeq: Integer);
var
  sql: string;
begin
  conPrjMng.StartTransaction;
  try
    if qryProjectMember.Locate('PRM_MEM_SEQ', AMemSeq) then
    begin
      ShowMessage('̹ ϵǾ ֽϴ.');
      Exit;
    end;

    qryProjectMember.Append;
    qryProjectMember.FieldByName('PRM_PRJ_SEQ').AsInteger := APrjSeq;
    qryProjectMember.FieldByName('PRM_MEM_SEQ').AsInteger := AMemSeq;
    qryProjectMember.Post;
//
//    sql := 'INSERT INTO PROJECTMEMBER(PRM_PRJ_SEQ, PRM_MEM_SEQ) ' +
//            ' VALUES(:PRJ_SEQ, :MEM_SEQ)';
//    qryUpdatePrjMem.SQL.Text := sql;
//    qryUpdatePrjMem.ParamByName('PRJ_SEQ').AsInteger := APrjSeq;
//    qryUpdatePrjMem.ParamByName('MEM_SEQ').AsInteger := AMemSeq;
//    qryUpdatePrjMem.ExecSQL;

    UpdateProjectMemberCount(APrjSeq);

    conPrjMng.Commit;
  except
    conPrjMng.Rollback;
  end;

  qryProjectMember.Refresh;
end;

procedure TdmDataAccess.DeleteProjectMember(const APrjSeq, AMemSeq: Integer);
var
  sql: string;
begin
  conPrjMng.StartTransaction;
  try
//    qryProjectMember.Delete;

    sql := 'DELETE FROM PROJECTMEMBER ' +
            ' WHERE PRM_PRJ_SEQ = :PRJ_SEQ AND PRM_MEM_SEQ = :MEM_SEQ';
    qryUpdatePrjMem.SQL.Text := sql;
    qryUpdatePrjMem.ParamByName('PRJ_SEQ').AsInteger := APrjSeq;
    qryUpdatePrjMem.ParamByName('MEM_SEQ').AsInteger := AMemSeq;
    qryUpdatePrjMem.ExecSQL;

    UpdateProjectMemberCount(APrjSeq);

    conPrjMng.Commit;
  except
    conPrjMng.Rollback;
  end;

  qryProjectMember.Refresh;
end;

// Ʈ ο Ʈ(ο ߰/   )
procedure TdmDataAccess.UpdateProjectMemberCount(const APrjSeq: Integer);
var
  MemCount: Integer;
begin
  qryUpdatePrjMem.SQL.Text := 'SELECT COUNT(*) FROM PROJECTMEMBER WHERE PRM_PRJ_SEQ = :PRJ_SEQ';
  qryUpdatePrjMem.ParamByName('PRJ_SEQ').AsInteger := APrjSeq;
  qryUpdatePrjMem.Open;
  MemCount := qryUpdatePrjMem.Fields[0].AsInteger;
  qryUpdatePrjMem.Close;

  tblProject.Edit;
  tblProject.FieldByName('PRJ_MEMBERCOUNT').AsInteger := MemCount;
  tblProject.Post;
end;

// Ʈ  : Ʈ ο Բ 
procedure TdmDataAccess.DataModuleCreate(Sender: TObject);
begin
  tblMember.AggregatesActive := True;
end;

procedure TdmDataAccess.DeleteProject;
var
  PrjSeq: Integer;
begin
  PrjSeq := tblProject.FieldByName('PRJ_SEQ').AsInteger;

  // ο, Ʈ ̺ Ʈ  ó(  )
  conPrjMng.StartTransaction;
  try
    qryUpdatePrjMem.SQL.Text := 'DELETE FROM PROJECTMEMBER WHERE PRM_PRJ_SEQ = :PRJ_SEQ';
    qryUpdatePrjMem.ParamByName('PRJ_SEQ').AsInteger := PrjSeq;
    qryUpdatePrjMem.ExecSQL;

    tblProject.Delete;
    tblProject.Post;

    conPrjMng.Commit;
  except
    conPrjMng.Rollback;
  end;
end;


procedure TdmDataAccess.tblMemberCalcFields(DataSet: TDataSet);
var
  YearSalary, MonthSalary: Integer;
begin
  YearSalary := tblMember.FieldByName('MEM_YEAR_SALARY').AsInteger;
  MonthSalary := YearSalary div 12;

  tblMember.FieldByName('MEM_MONTH_SALARY').AsInteger := MonthSalary;

end;

procedure TdmDataAccess.tblProjectCalcFields(DataSet: TDataSet);
var
  StatusCode: Integer;
  StatusCodeStr: string;
begin
  StatusCode := DataSet.FieldByName('PRJ_STATUS_CODE').AsInteger;

  case StatusCode of
  10: StatusCodeStr := '';
  20: StatusCodeStr := '';
  30: StatusCodeStr := '';
  else
    StatusCodeStr := '-';
  end;
  tblProjectPRJ_STATUS.Value := StatusCodeStr;
//  DataSet.FieldByName('PRJ_STATUS').Value := StatusCodeStr;
//   ڵ
end;

procedure TdmDataAccess.tblProjectNewRecord(DataSet: TDataSet);
begin
  tblProjectPRJ_MEMBERCOUNT.Value := 0;
end;

end.
