unit DeptForm;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Data.DB, Vcl.Grids, Vcl.DBGrids,
  Vcl.ExtCtrls, Vcl.StdCtrls, Vcl.Mask, Vcl.DBCtrls, FireDAC.Stan.Intf,
  FireDAC.Stan.Option, FireDAC.Stan.Param, FireDAC.Stan.Error, FireDAC.DatS,
  FireDAC.Phys.Intf, FireDAC.DApt.Intf, FireDAC.Stan.Async, FireDAC.DApt,
  FireDAC.Comp.DataSet, FireDAC.Comp.Client;

type
  TfrmDept = class(TForm)
    grdDept: TDBGrid;
    dsDept: TDataSource;
    Panel2: TPanel;
    edtDept: TDBEdit;
    edtTeam: TDBEdit;
    Label1: TLabel;
    Label2: TLabel;
    btnAdd: TButton;
    btnSave: TButton;
    btnCancel: TButton;
    btnDelete: TButton;
    Label3: TLabel;
    btnClose: TButton;
    qryMemCntByDept: TFDQuery;
    procedure btnAddClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure btnSaveClick(Sender: TObject);
    procedure btnDeleteClick(Sender: TObject);
    procedure dsDeptStateChange(Sender: TObject);
    procedure btnCancelClick(Sender: TObject);
    procedure btnCloseClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmDept: TfrmDept;

implementation

{$R *.dfm}

uses DataAccessModule;

procedure TfrmDept.btnAddClick(Sender: TObject);
begin
  dmDataAccess.tblDept.Append;
  edtDept.SetFocus;
end;

procedure TfrmDept.btnCancelClick(Sender: TObject);
begin
  dmDataAccess.tblDept.Cancel;
end;

procedure TfrmDept.btnCloseClick(Sender: TObject);
begin
  Close;
end;

procedure TfrmDept.btnDeleteClick(Sender: TObject);
var
  Dept: string;
  DeptSeq, Count: Integer;
begin
  //////////////////////////////////////////////////////////////
  // μ   Ҽο   
    // (#)  ÷׸ ΰ  ϸ  ȿ Ȯ  
  Dept := dmDataAccess.tblDept.FieldByName('DPT_TEAM').AsString;
  DeptSeq := dmDataAccess.tblDept.FieldByName('DPT_SEQ').AsInteger;

  qryMemCntByDept.ParamByName('DPT_SEQ').Value := DeptSeq;
  qryMemCntByDept.Open;

  // SELECT COUNT(*) ̿  1
    // qryMemCntByDept.EOF Ͱ ִ Ȯ  Fields(or FieldByName) ؾ 
    //    ޸   ߻
  Count := qryMemCntByDept.Fields[0].AsInteger;
  if Count > 0 then
  begin
    ShowMessage(Format('[%s] μ Ҽ  [%d] ֽϴ.' +
          #13#10'  μ   ϴ.', [Dept, Count]));
    Exit;
  end;
  //////////////////////////////////////////////////////////////

  if MessageDlg('μ Ͻðڽϱ?', mtConfirmation, [mbYes, mbNo], 0) = mrYes then
  begin
    dmDataAccess.tblDept.Delete;
  end;
end;

procedure TfrmDept.btnSaveClick(Sender: TObject);
begin
  if edtDept.Text = '' then
  begin
    ShowMessage('μ Էϼ.');
    edtDept.SetFocus;
    Exit;
  end;

  if edtTeam.Text = '' then
  begin
    ShowMessage(' Էϼ.');
    edtTeam.SetFocus;
    Exit;
  end;

  dmDataAccess.tblDept.Post;
end;

procedure TfrmDept.dsDeptStateChange(Sender: TObject);
var
  DataSet: TDataSet;
begin
  DataSet := dmDataAccess.tblDept;

  btnSave.Enabled := DataSet.State in [dsInsert, dsEdit];
  btnCancel.Enabled := DataSet.State in [dsInsert, dsEdit];

  btnDelete.Enabled := DataSet.State = dsBrowse;
end;

procedure TfrmDept.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  if dmDataAccess.tblDept.State in [dsInsert, dsEdit] then
    dmDataAccess.tblDept.Cancel;
  Action := caFree;
  frmDept := nil;
end;

end.
