unit MemberForm;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Data.DB, Vcl.Grids, Vcl.DBGrids,
  Vcl.StdCtrls, Vcl.Mask, Vcl.DBCtrls, Vcl.ExtCtrls, FireDAC.Stan.Intf,
  FireDAC.Stan.Option, FireDAC.Stan.Param, FireDAC.Stan.Error, FireDAC.DatS,
  FireDAC.Phys.Intf, FireDAC.DApt.Intf, FireDAC.Stan.Async, FireDAC.DApt,
  FireDAC.Comp.DataSet, FireDAC.Comp.Client;

type
  TfrmMember = class(TForm)
    Label3: TLabel;
    btnAdd: TButton;
    dsMember: TDataSource;
    Panel2: TPanel;
    Label1: TLabel;
    Label2: TLabel;
    btnSave: TButton;
    btnCancel: TButton;
    btnDelete: TButton;
    edtName: TDBEdit;
    cbxTeam: TDBLookupComboBox;
    dsDept: TDataSource;
    qryProjectCountByMem: TFDQuery;
    btnClose: TButton;
    DBEdit1: TDBEdit;
    Label4: TLabel;
    Panel1: TPanel;
    DBGrid1: TDBGrid;
    Panel3: TPanel;
    DBEdit2: TDBEdit;
    Label5: TLabel;
    procedure btnAddClick(Sender: TObject);
    procedure btnSaveClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure btnDeleteClick(Sender: TObject);
    procedure dsMemberStateChange(Sender: TObject);
    procedure btnCloseClick(Sender: TObject);
    procedure btnCancelClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmMember: TfrmMember;

implementation

{$R *.dfm}

uses DataAccessModule;

procedure TfrmMember.btnAddClick(Sender: TObject);
begin
  dmDataAccess.tblMember.Append;
  edtName.SetFocus;
end;

procedure TfrmMember.btnCancelClick(Sender: TObject);
begin
  dmDataAccess.tblMember.Cancel;
end;

procedure TfrmMember.btnCloseClick(Sender: TObject);
begin
  Close;
end;

procedure TfrmMember.btnDeleteClick(Sender: TObject);
var
  MemSeq, PrjCount: Integer;
begin
  MemSeq := dmDataAccess.tblMember.FieldByName('MEM_SEQ').AsInteger;

  qryProjectCountByMem.ParamByName('MEM_SEQ').Value := MemSeq;
  qryProjectCountByMem.Open;

  // SELECT COUNT(*) ̿  1
    // qryProjectCountByMem.EOF Ͱ ִ Ȯ  Fields(or FieldByName) ؾ 
    //    ޸   ߻
  PrjCount := qryProjectCountByMem.Fields[0].AsInteger;
  if PrjCount > 0 then
  begin
    ShowMessage(' Ʈ ־    ϴ.');
    Exit;
  end;

  if MessageDlg('ش  Ͻðڽϱ?', mtConfirmation, [mbYes, mbNo], 0) = mrYes then
  begin
    dmDataAccess.tblMember.Delete;
  end;
end;

procedure TfrmMember.btnSaveClick(Sender: TObject);
begin
  if edtName.Text = '' then
  begin
    ShowMessage('̸ Էϼ.');
    edtName.SetFocus;
    Exit;
  end;

  dmDataAccess.tblMember.Post;
end;

procedure TfrmMember.dsMemberStateChange(Sender: TObject);
var
  DataSet: TDataSet;
begin
  DataSet := dmDataAccess.tblMember;

  btnSave.Enabled := DataSet.State in [dsInsert, dsEdit];
  btnCancel.Enabled := DataSet.State in [dsInsert, dsEdit];

  btnDelete.Enabled := DataSet.State = dsBrowse;
end;

procedure TfrmMember.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  // Է  ̸ ϰ 
  if dmDataAccess.tblMember.State in [dsInsert, dsEdit] then
    dmDataAccess.tblMember.Cancel;
  frmMember := nil;
  Action := caFree;
end;

end.
