unit ProjectForm;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Data.DB, FireDAC.Stan.Intf,
  FireDAC.Stan.Option, FireDAC.Stan.Param, FireDAC.Stan.Error, FireDAC.DatS,
  FireDAC.Phys.Intf, FireDAC.DApt.Intf, FireDAC.Stan.Async, FireDAC.DApt,
  FireDAC.Comp.DataSet, FireDAC.Comp.Client, Vcl.Grids, Vcl.DBGrids,
  Vcl.DBCtrls, Vcl.StdCtrls, Vcl.Mask, Vcl.ExtCtrls, Vcl.ComCtrls;

type
  TfrmProject = class(TForm)
    Label3: TLabel;
    btnAdd: TButton;
    btnClose: TButton;
    DBGrid1: TDBGrid;
    dsProject: TDataSource;
    Panel1: TPanel;
    Panel2: TPanel;
    Label1: TLabel;
    Label2: TLabel;
    btnSave: TButton;
    btnCancel: TButton;
    btnDelete: TButton;
    Panel3: TPanel;
    Panel4: TPanel;
    DBGrid2: TDBGrid;
    edtName: TDBEdit;
    edtStart: TDBEdit;
    edtEnd: TDBEdit;
    Label4: TLabel;
    cbxManager: TDBLookupComboBox;
    Label5: TLabel;
    dsPMMember: TDataSource;
    Label6: TLabel;
    rdgStatus: TDBRadioGroup;
    Label7: TLabel;
    btnPrjMemAdd: TButton;
    btnPrjMemDelete: TButton;
    dsProjectMember: TDataSource;
    DateTimePicker1: TDateTimePicker;
    procedure btnAddClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure btnSaveClick(Sender: TObject);
    procedure btnCloseClick(Sender: TObject);
    procedure btnCancelClick(Sender: TObject);
    procedure dsProjectStateChange(Sender: TObject);
    procedure btnPrjMemAddClick(Sender: TObject);
    procedure btnPrjMemDeleteClick(Sender: TObject);
    procedure btnDeleteClick(Sender: TObject);
    procedure dsProjectDataChange(Sender: TObject; Field: TField);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmProject: TfrmProject;

implementation

{$R *.dfm}

uses DataAccessModule, SelectPrjMemForm;

procedure TfrmProject.btnAddClick(Sender: TObject);
begin
  dmDataAccess.tblProject.Append;
  edtName.SetFocus;
end;

procedure TfrmProject.btnCancelClick(Sender: TObject);
begin
  dmDataAccess.tblProject.Cancel;
end;

procedure TfrmProject.btnCloseClick(Sender: TObject);
begin
  Close;
end;

procedure TfrmProject.btnDeleteClick(Sender: TObject);
begin
  if MessageDlg('ش Ʈ Ͻðڽϱ?', mtConfirmation, [mbYes, mbNo], 0) = mrYes then
  begin
    dmDataAccess.DeleteProject;
  end;
end;

procedure TfrmProject.btnSaveClick(Sender: TObject);
begin
  if edtName.Text = '' then
  begin
    ShowMessage('Ʈ  Էϼ.');
    edtName.SetFocus;
    Exit;
  end;

  dmDataAccess.tblProject.FieldByName('PRJ_STARTDATE').AsDateTime
          := DateTimePicker1.Date;
  dmDataAccess.tblProject.Post;
end;

procedure TfrmProject.btnPrjMemAddClick(Sender: TObject);
var
  PrjSeq, MemSeq: Integer;
begin
  frmSelectPrjMem := TfrmSelectPrjMem.Create(nil);
  try
    if frmSelectPrjMem.ShowModal <> mrOk then
      Exit;
    MemSeq := frmSelectPrjMem.SelectedMemSeq;
    if MemSeq > 0 then
    begin
      PrjSeq := dmDataAccess.tblProject.FieldByName('PRJ_SEQ').AsInteger;

      dmDataAccess.AppendProjectMember(PrjSeq, MemSeq);
    end;
  finally
    frmSelectPrjMem.Free;
  end;
end;

procedure TfrmProject.btnPrjMemDeleteClick(Sender: TObject);
var
  PrjSeq, MemSeq: Integer;
begin
  if MessageDlg('ش ο Ͻðڽϱ?', mtConfirmation, [mbYes, mbNo], 0) = mrYes then
  begin
    PrjSeq := dmDataAccess.tblProject.FieldByName('PRJ_SEQ').AsInteger;
    MemSeq := dmDataAccess.qryProjectMember.FieldByName('PRM_MEM_SEQ').AsInteger;
    dmDataAccess.DeleteProjectMember(PrjSeq, MemSeq);
  end;
end;

procedure TfrmProject.dsProjectDataChange(Sender: TObject; Field: TField);
begin
  DateTimePicker1.Date := dsProject.DataSet.FieldByName('PRJ_STARTDATE').AsDateTime;
end;

procedure TfrmProject.dsProjectStateChange(Sender: TObject);
var
  DataSet: TDataSet;
begin
  DataSet := dmDataAccess.tblProject;

  btnSave.Enabled := DataSet.State in [dsInsert, dsEdit];
  btnCancel.Enabled := DataSet.State in [dsInsert, dsEdit];

  btnDelete.Enabled := DataSet.State = dsBrowse;
end;

procedure TfrmProject.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  // Է  ̸ ϰ 
  if dmDataAccess.tblProject.State in [dsInsert, dsEdit] then
    dmDataAccess.tblProject.Cancel;
  frmProject := nil;
  Action := caFree;
end;

end.
